# v1.0.0 Change Log

## Goal

This release aims to standardize library's property creation methodology.

* [x] Standardize on StateType use instead of mixing with explicit property creation parameters
* [x] Allow property class specType to be specialized
* [x] Add Collection support for specType
* [x] Add Collection endpoint support for stubbed data (PojoEndpointProperty)
* [x] Collection todo example
* [x] Remove stateSpec references (rely on type mechanism)
* [x] Remove KeyedProperty, StateTypes, and createXyzPropertyType() functions
* [x] Create IndexedApi class to mirror KeyedApi
* [ ] Basic todo example
* [ ] Tutorial or quick start based on todo example (optional)


## Changes


### Libraries

* (uuid)[https://github.com/kelektiv/node-uuid]


### ArrayProperty

* createClass(shadowType={}, specCallback, initialState=[]) signature changed


### IndexedProperty

* Constructor takes single argument of StateType
* createClass(shadowType={}, specCallback, initialState=[]) signature changed


### MapProperty

* createClass(shadowType={}, specCallback, initialState=[]) signature changed


### ObjectProperty

* Constructor takes single argument of StateType
* Use ObjectShadowImpl
* createClass(shadowType={}, specCallback, initialState=[]) signature changed


### Property

* Constructor takes single argument of StateType. If one not passed as parameter then default located in the property's prototype chain.


### PropertyFactoryShader

* Constructor signature: constructor(stateType, parent)
* Replaed setElementClass() with setElementType(stateType)
* addStateType() -> addProperty(name, stateType)
* addPropertyClass() removed


### Shader

* addStateType() -> addProperty(name, stateType)
* addPropertyClass() removed


### StateType

* computeInitialState() now non-static and no arguments
* shadowClassForProperty(defaultClass=Shadow) signature changed and no longer static
* initialStateWithDefaults(state) signature changed and no longer static
* from(prop) static method to walk the prototype hieararchy looking for a StateType instance on the constructor: stateSpec or type properties in that order


### createPropertyClass()

* Signature changed: createPropertyClass(shadowType, initialState, specCallback, PropertyClass, BaseShadowClass=Shadow)


### Examples

* Todo with Collections


